/******************************************************************************
*
*  FILENAME :	bugbyte.h
*
*  DESCRIPTION :
*
*	Programmer's standard header file.
*
*  USAGE :
*
*	Include in any source files or headers written by the author,
*	which require it.
*
*  NOTES :
*
*	May still need to include other files to use macros.
*
*	Written by Paul Chesson (1994)
*	E-Mail: chesson@mundil.cs.mu.OZ.AU
*
*/


#ifndef BUGBYTE_H
#define BUGBYTE_H


/******************************************************************************
*  DATA DESCRIPTIONS
******************************************************************************/

/* ----- typedefs ---------------------------------------------------------- */

typedef short Boolean;

/* ----- constants --------------------------------------------------------- */

#ifndef	TRUE
#define	TRUE		1		/* Boolean */
#endif
#ifndef	FALSE
#define	FALSE		0		/* Boolean */
#endif
#ifndef	NULL
#define	NULL		0
#endif
#ifndef	ERROR
#define	ERROR		-1		/* Abnormmal function termination */
#endif
#ifndef OK
#define OK		0		/* Normal function termination */
#endif

/* ----- character constants ----------------------------------------------- */

#define NUL		'\0'
#define SPC		' '
#define TAB		'\t'
#define NL		'\n'

/* ----- numerical comparisons --------------------------------------------- */

#define	MAX(A, B)			((A) > (B) ? (A) : (B))
#define	MIN(A, B)			((A) < (B) ? (A) : (B))

/* ----- string comparisons ----------- #include <string.h> ---------------- */

#define STR_EQ(STR1, STR2)		(strcmp(STR1, STR2) == 0)
#define STR_DIFF(STR1, STR2)		(strcmp(STR1, STR2) != 0)
#define STRN_EQ(STR1, STR2, N)		(strncmp(STR1, STR2, N) == 0)
#define STRN_DIFF(STR1, STR2, N)	(strncmp(STR1, STR2, N) != 0)

/* ----- error handling --------------- #include <errno.h> ----------------- */

#define FATAL(ERR_ID)			{ perror(ERR_ID); exit(errno); }

/* ----- memory allocation ------------ #include <stdlib.h> <errno.h> ------ */

#define MALLOC_TYPE(VAR, TYPE, N)					\
{									\
    if ( ((VAR) = (TYPE *) malloc((N) * sizeof(TYPE))) == 0 ) 		\
	FATAL("malloc");						\
}


#endif  /*  BUGBYTE_H  */

